local testimtopic = ""
local testimcolor = SKINCOLOR_BLUE
local testimplayer
local textpos = 0
local barpos = 0

COM_AddCommand("testify", function(p, arg)
	if gamestate != 1 then
		CONS_Printf(p, "You can only do this in gameplay.")
		return
	end
	
	if testimonyprogress then
		CONS_Printf(p, "You can't testify while someone else is testifying.")
		return
	end
	
	if examinationprogress then
		examinationprogress = 0
	end
	
	if arg then
		testimtopic = arg
	else
		testimtopic = "Witness's Account"
	end
	testimplayer = p
	if recolorcutins then
		testimcolor = testimplayer.mo.color
	else
		testimcolor = SKINCOLOR_BLUE
	end
	testimonyprogress = 1
	chatprint("\x82* "..testimplayer.name.." would like to testify!")
	chatprint("\x82*\x80 Testimony topic: \x87"..testimtopic)
	S_StartSound(nil, sfx_aawitn)
end)

COM_AddCommand("endtestimony", function(p)
	if gamestate != 1 then
		CONS_Printf(p, "You can only do this in gameplay.")
		return
	end
	
	if not testimonyprogress then
		CONS_Printf(p, "Nobody is testifing right now.")
		return
	end
	
	testimonyprogress = 0
	chatprint("\x82* This is the end of "..testimplayer.name.."'s testimony.")
end, COM_ADMIN)

addHook("MapLoad", do
	testimonyprogress = 0
end)

addHook("PlayerThink", function(p)
	if gamestate != 1 then return end
	
	if testimonyprogress == 12 then
		P_FlashPal(p, PAL_WHITE, TICRATE/4)
	end
end)

hud.add(function(v, p, c)
	if not testimonyprogress then return end
	
	if testimonyprogress == 3*TICRATE then
		S_StartSound(nil, sfx_aatrns, p)
	end
	
	if testimonyprogress >= 3*TICRATE and testimonyprogress <= 7*TICRATE/2 then
		textpos = $+19
	elseif testimonyprogress < 12
		textpos = -320+testimonyprogress*27
	else
		textpos = 0
	end
	if barpos == 320 then
		barpos = 0
	else
		barpos = $+1
	end
	
	if testimonyprogress <= 7*TICRATE/2 then
		v.draw(textpos, 0, v.cachePatch("AAWITN"), 0, v.getColormap("sonic", testimcolor))
		v.draw(-textpos, 0, v.cachePatch("AATSTM"), 0, v.getColormap("sonic", testimcolor))
	elseif testimonyprogress <= 7*TICRATE/2+3*TICRATE then
		v.drawString(160, 100, "== "..testimtopic.." ==", V_ORANGEMAP, "thin-center")
	end
	if testimonyprogress >= 12 then
		v.draw(barpos, 0, v.cachePatch("AATSTMB"), 0, v.getColormap("sonic", testimcolor))
		v.draw(-barpos, 188, v.cachePatch("AATSTMB"), 0, v.getColormap("sonic", testimcolor))
		v.draw(-320+barpos, 0, v.cachePatch("AATSTMB"), 0, v.getColormap("sonic", testimcolor))
		v.draw(320-barpos, 188, v.cachePatch("AATSTMB"), 0, v.getColormap("sonic", testimcolor))
	end
	if testimonyprogress <= 7*TICRATE/2+3*TICRATE then
		testimonyprogress = $+1
	end
end, "game")